/* Aistė Valaitytė, FDM II kursas, I grupė, aiste.valaityte@gmail.com
[A-1] variantas 15.
Su pasirinktais įrašais realizuoti ADT steko operacijas masyvo pagrindu;
Su pasirinktais įrašais realizuoti ADT sąrašo operacijas dinaminio vienakrypčio sąrašo pagrindu. */
//==============================================================================
import java.util.*;
import java.io.*;
//==============================================================================
public class Mainpaskutinis
{
  public static void main (String[] args) throws FileNotFoundException, IOException
  {
    InputStreamReader ISR = new InputStreamReader(System.in);
    BufferedReader BR = new BufferedReader(ISR);
	  System.out.println (" ***DEKLAS***  ");
	 Deklas masyvas = new Deklas (100);
    masyvas.skaityk ();
    System.out.println ("Visas deklas:");
    masyvas.spausdink ();
    System.out.println ("Paskutinis iterptas elementas:");
    masyvas.spausdintiPask();
	 System.out.println ("Iveskite nauja elementa:");
    masyvas.padetiIsEkrano ();
    masyvas.spausdink ();
    System.out.println ("Pasalintas paskutinis elementas:");
    masyvas.nuimti ();
    masyvas.spausdink ();
	 System.out.println ("  ***SARASAS***  ");
    TiesDinSar sarasas = new TiesDinSar ();
    sarasas.skaityk ();
    System.out.println ("Visas sarasas:");
    sarasas.spausdink ();
    System.out.println ("Iveskite saraso elementa ir numeri:");
    StringTokenizer dalina = new StringTokenizer (BR.readLine ());
    Kelnes duom = new Kelnes (dalina.nextToken (), Integer.parseInt (dalina.nextToken ()),  dalina.nextToken ().charAt (0),
                         dalina.nextToken ().equals ("Naujos") ? true : false,
                        Double.parseDouble (dalina.nextToken ()));
    int t = Integer.parseInt(BR.readLine());
    sarasas.iterpti(duom,t);
    sarasas.spausdink();
    System.out.println ("Iveskite saraso elemento numeri, kuri norite atspausdinti:");
    int m = Integer.parseInt(BR.readLine());
    sarasas.spausdinti (m);
    System.out.println ("Iveskite saraso elemento numeri, kuri norite pasalinti:");
    int n = Integer.parseInt(BR.readLine());
    sarasas.trinti (n);
    System.out.println ("Sarasas su pasalintu elementu:");
    sarasas.spausdink ();
  }
}
//==============================================================================
class Deklas
{
  private Kelnes[] masyvas;
  private int galas;
  public Deklas (int dydis)
  {
    masyvas = new Kelnes[dydis];
    galas = -1;
  }
  public void padeti (Kelnes duomuo)
  {
    if (galas != masyvas.length - 1)
    {
      galas++;
      masyvas[galas] = duomuo;
    }
  }
  public void padetiIsEkrano () throws IOException
  {
    BufferedReader skait = new BufferedReader(new InputStreamReader (System.in));
    StringTokenizer dalina = new StringTokenizer (skait.readLine ());
    padeti (new Kelnes (dalina.nextToken (), Integer.parseInt (dalina.nextToken ()),  dalina.nextToken ().charAt (0),
                         dalina.nextToken ().equals ("Naujos") ? true : false,
                        Double.parseDouble (dalina.nextToken ())));
  }
  public void nuimti ()
  {
    if (galas >= 0)
      galas--;
  }
  public void spausdintiPask () throws IOException
  {

    if (galas >= 0)
    {
      Kelnes duomuo = masyvas[galas];
      System.out.println (duomuo.gamintojas () + "\t" + duomuo.dydis () + "\t" +
                          duomuo.ugis () + "\t" + (duomuo.naujas () ? "Naujos" : "Devetos") + "\t" +
                          duomuo.kaina ());
      System.out.println ();
    }
  }
  public void spausdink () throws IOException
  {
    for (int i = 0; i <= galas; i++)
    {
      Kelnes duomuo = masyvas[i];
      System.out.println (duomuo.gamintojas () + "\t" + duomuo.dydis () + "\t" +
                          duomuo.ugis () + "\t" + (duomuo.naujas () ? "Naujos" : "Devetos") + "\t" +
                          duomuo.kaina ());
    }
    if (galas >= 0)
      System.out.println ();
  }
  public void skaityk () throws FileNotFoundException, IOException
  {

    InputStreamReader ISR = new InputStreamReader(System.in);
    BufferedReader skait = new BufferedReader(ISR);
	try {
  	 System.out.println ("Iveskite duomenu faila:");
	 skait = new BufferedReader (new FileReader (skait.readLine()));
	 StringTokenizer dalina;
	 String eilute = skait.readLine ();
	 while (eilute != null)
	 {
	    dalina = new StringTokenizer (eilute);
		padeti ( new Kelnes (dalina.nextToken (), Integer.parseInt (dalina.nextToken ()),
                dalina.nextToken ().charAt (0), dalina.nextToken ().equals ("Naujos") ? true : false,
                Double.parseDouble (dalina.nextToken ())));
		eilute = skait.readLine ();
	}
    skait.close ();
	}
	catch (FileNotFoundException ex)
    {
      System.out.println("Toks duomenu failas nerastas");
    }
  }
}
//==============================================================================
class DinSarElem
{
  private Kelnes duomuo;
  private DinSarElem kitas;
  public DinSarElem (Kelnes duomuo)
  {
    this.duomuo = duomuo;
    kitas = null;
  }
  public void detKitas (DinSarElem kitas)
  {
    this.kitas = kitas;
  }
  public Kelnes duomuo ()
  {
    return duomuo;
  }
  public DinSarElem kitas ()
  {
    return kitas;
  }
}
//==============================================================================
class Kelnes
{
  private String gamint;
  private int ugis;
  private char dydis;
  private boolean naujas;
  private double kaina;
  public Kelnes (String gamint, int ugis, char dydis, boolean naujas, double kaina)
  {
    this.gamint = gamint;
    this.ugis = ugis;
    this.dydis = dydis;
    this.naujas = naujas;
    this.kaina = kaina;
  }
  public String gamintojas ()
  {
    return gamint;
  }
  public int ugis ()
  {
    return ugis;
  }
  public char dydis ()
  {
    return dydis;
  }
  public boolean naujas ()
  {
    return naujas;
  }
  public double kaina ()
  {
    return kaina;
  }
}
//==============================================================================
class TiesDinSar
{
  private DinSarElem saknis;
  public TiesDinSar ()
  {
    saknis = null;
  }
  
  public void iterpti (Kelnes duomuo, int vieta)
  {
    DinSarElem rodykle = saknis, laik;
    int i = 2;
    if (rodykle == null || vieta == 1)
    {
      laik = new DinSarElem (duomuo);
      laik.detKitas (saknis);
      saknis = laik;
    }
    else
      if (vieta > 1)
      {
        while (rodykle.kitas () != null && i < vieta)
        {
          rodykle = rodykle.kitas ();
          i++;
        }
        if (i == vieta)
        {
          laik = rodykle.kitas ();
          rodykle.detKitas (new DinSarElem (duomuo));
          rodykle.kitas ().detKitas (laik);
        }
      }
  }
  
  public void trinti (int vieta)
  {
    DinSarElem rodykle = saknis;
    int i = 2;
    if (vieta > 0 && saknis != null)
    {
      if (vieta == 1)
        saknis = saknis.kitas ();
      else
      {
        while (rodykle.kitas () != null && i < vieta)
        {
          rodykle = rodykle.kitas ();
          i++;
        }
        if (rodykle.kitas () != null && i == vieta)
          rodykle.detKitas (rodykle.kitas ().kitas ());
      }
    }
  }
  public void naikinti ()
  {
    saknis = null;
  }
  public void spausdinti (int vieta) throws IOException
  {
    DinSarElem rodykle = saknis;
    int i = 1;
    while (rodykle != null && i < vieta)
    {
      rodykle = rodykle.kitas ();
      i++;
    }
    if (i > 0 && i == vieta)
    {
      Kelnes duomuo = rodykle.duomuo ();
      System.out.println (duomuo.gamintojas () + "\t" + duomuo.dydis () + "\t" +
                          duomuo.ugis () + "\t" + (duomuo.naujas () ? "Naujos" : "Devetos") + "\t" +
                          duomuo.kaina ());
      System.out.println ();
    }
  }
  public void spausdink () throws IOException
  {
    DinSarElem rodykle = saknis;
    while (rodykle != null)
    {
      Kelnes duomuo = rodykle.duomuo ();
      System.out.println (duomuo.gamintojas () + "\t" + duomuo.dydis () + "\t" +
                          duomuo.ugis () + "\t" + (duomuo.naujas () ? "Naujos" : "Devetos") + "\t" +
                          duomuo.kaina ());
      rodykle = rodykle.kitas ();
    }
    if (saknis != null)
      System.out.println ();
  }
  public void skaityk () throws FileNotFoundException, IOException
  {
	InputStreamReader ISR = new InputStreamReader(System.in);
    BufferedReader skait = new BufferedReader(ISR);
	try {
  	System.out.println ("Iveskite duomenu faila:");
	  skait = new BufferedReader (new FileReader (skait.readLine()));
    StringTokenizer dalina;
    String eilute = skait.readLine ();
    while (eilute != null)
    {
      dalina = new StringTokenizer (eilute);
      iterpti ( new Kelnes (dalina.nextToken (), Integer.parseInt (dalina.nextToken ()),
                               dalina.nextToken ().charAt (0), dalina.nextToken ().equals ("Naujos") ? true : false,
                               Double.parseDouble (dalina.nextToken ())), 1);
      eilute = skait.readLine ();
    }
    skait.close ();
	}
	   catch (FileNotFoundException ex)
       {
		System.out.println("Toks duomenu failas nerastas");
	   }
  }

}
//==============================================================================